VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
'Setup some structures to store our keys in
Private Type key
    fun As String
    key As String
    bang As String
End Type
Private keys() As key

'mWndProcOrg holds the original address of the
'Window Procedure for this window. This is used to
'route messages to the original procedure after you
'process them.
Private mWndProcOrg As Long

'Handle (hWnd) of the subclassed window.
Private mHWndSubClassed As Long

'Constant for Windows Message used in sample.
Private Const WM_MOUSEACTIVATE = &H21

'This plugins form
Private m_oForm As hotkey.frmDummy

'The name of this instance
Private m_sName As String
Private Function IBasePlugin_StartPlugin(Name As String) As Long
    
    Dim temp As String
    Dim i As Long
    Dim ret As Long
    
    Set oServer = CreateObject("core.CServer")
    
    m_sName = Name
        
    ReDim keys(0)
    temp = oServer.GetKey(m_sName, "key1")
    i = 1
    While temp <> ""
        If InStr(temp, "+") = 0 Then
            oServer.Execute "!log core.key - error in syntax of key " & i & ", + expected"
        Else
            If InStr(temp, ":") = 0 Then
                oServer.Execute "!log core.key - error in syntax of key " & i & ", : expected"
            Else
                ReDim Preserve keys(UBound(keys) + 1)
                keys(UBound(keys)).fun = Left(temp, InStr(temp, "+") - 1)
                temp = Right(temp, Len(temp) - InStr(temp, "+"))
                keys(UBound(keys)).key = Left(temp, InStr(temp, ":") - 1)
                keys(UBound(keys)).bang = Right(temp, Len(temp) - InStr(temp, ":"))
            End If
        End If
        i = i + 1
        temp = oServer.GetKey(m_sName, "key" & i)
    Wend
    
    Set m_oForm = New hotkey.frmDummy
    Call Load(m_oForm)
    m_oForm.Tag = Name
    
    For i = 1 To UBound(keys)
        If RegisterHotKey(m_oForm.hwnd, i, whatKey(keys(i).fun), whatKey(keys(i).key)) <> 1 Then
            oServer.Execute "!log core.key - error: could not register key " & i & " it might already be registered by some other running application."
        End If
    Next i
    
    SubClass
    IBasePlugin_StartPlugin = m_oForm.hwnd

End Function
Private Sub IBasePlugin_StopPlugin()
    
    Dim i As Long
    Dim ret As Long
    
    For i = 1 To UBound(keys)
        ret = UnregisterHotKey(m_oForm.hwnd, i)
        If Not ret Then
            oServer.Execute "!log core.key - error: could not unregister key " & i & ", it probably wasn't registered."
        End If
    Next i
    UnSubClass
    Call Unload(m_oForm)
    Set m_oForm = Nothing

End Sub
Private Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)

End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Private Function whatKey(key As String) As Long

    If Len(key) = 1 Then
        whatKey = Asc(UCase(key))
    Else
        Select Case UCase(key)
        Case "CTRL"
            whatKey = &H2
        Case "SHFT"
            whatKey = &H4
        Case "ALT"
            whatKey = &H1
        Case "NUMPAD0"
            whatKey = &H60
        Case "NUMPAD1"
            whatKey = &H61
        Case "NUMPAD2"
            whatKey = &H62
        Case "NUMPAD3"
            whatKey = &H63
        Case "NUMPAD4"
            whatKey = &H64
        Case "NUMPAD5"
            whatKey = &H65
        Case "NUMPAD6"
            whatKey = &H66
        Case "NUMPAD7"
            whatKey = &H67
        Case "NUMPAD8"
            whatKey = &H68
        Case "NUMPAD9"
            whatKey = &H69
        Case "MULTIPLY"
            whatKey = &H6A
        Case "ADD"
            whatKey = &H6B
        Case "SEPARATOR"
            whatKey = &H6C
        Case "SUBTRACT"
            whatKey = &H6D
        Case "DECIMAL"
            whatKey = &H6E
        Case "DIVIDE"
            whatKey = &H6F
        Case "F1"
            whatKey = &H70
        Case "F2"
            whatKey = &H71
        Case "F3"
            whatKey = &H72
        Case "F4"
            whatKey = &H73
        Case "F5"
            whatKey = &H74
        Case "F6"
            whatKey = &H75
        Case "F7"
            whatKey = &H76
        Case "F8"
            whatKey = &H77
        Case "F9"
            whatKey = &H78
        Case "F10"
            whatKey = &H79
        Case "F11"
            whatKey = &H7A
        Case "F12"
            whatKey = &H7B
        Case "F13"
            whatKey = &H7C
        Case "F14"
            whatKey = &H7D
        Case "F15"
            whatKey = &H7E
        Case "F16"
            whatKey = &H7F
        Case "F17"
            whatKey = &H80
        Case "F18"
            whatKey = &H81
        Case "F19"
            whatKey = &H82
        Case "F20"
            whatKey = &H83
        Case "F21"
            whatKey = &H84
        Case "F22"
            whatKey = &H85
        Case "F23"
            whatKey = &H86
        Case "F24"
            whatKey = &H87
        Case Else
            oServer.Execute "!log core.key - error: unknown key value"
            whatKey = 0
        End Select
    End If

End Function
Private Sub SubClass()
   
    If mWndProcOrg Then Exit Sub

    mWndProcOrg = SetWindowLong(m_oForm.hwnd, GWL_WNDPROC, AddressOf SubWndProc)

    mHWndSubClassed = m_oForm.hwnd

    Call SetWindowLong(m_oForm.hwnd, GWL_USERDATA, ObjPtr(Me))

End Sub
Private Sub UnSubClass()
   
   If mWndProcOrg = 0 Then Exit Sub

   SetWindowLong mHWndSubClassed, GWL_WNDPROC, mWndProcOrg
   mWndProcOrg = 0

End Sub
Friend Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Dim retval As Long
    
    Select Case uMsg
        Case WM_HOTKEY
            oServer.Execute keys(wParam).bang
        Case Else
            retval = CallWindowProc(mWndProcOrg, m_oForm.hwnd, uMsg, wParam, ByVal lParam)
    End Select
        
    WindowProc = retval

End Function
