Attribute VB_Name = "modGlobal"
Option Explicit
Public oServer As core.CServer
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal ByteLen As Long)
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function RegisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Public Declare Function UnregisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long) As Long

'Constants for GetWindowLong() and SetWindowLong() APIs.
Public Const GWL_WNDPROC = (-4)
Public Const GWL_USERDATA = (-21)
Public Const WM_HOTKEY = &H312

'Used to hold a reference to the control to call its procedure.
'NOTE: "UserControl1" is the UserControl.Name Property at
'      design-time of the .CTL file.
'      ('As Object' or 'As Control' does not work)
Dim oPlugin As CPlugin

'Used as a pointer to the UserData section of a window.
Dim ptrObject As Long
'The address of this function is used for subclassing.
'Messages will be sent here and then forwarded to the
'UserControl's WindowProc function. The HWND determines
'to which control the message is sent.
Public Function SubWndProc(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

   On Error Resume Next

   'Get pointer to the control's VTable from the
   'window's UserData section. The VTable is an internal
   'structure that contains pointers to the methods and
   'properties of the control.
   ptrObject = GetWindowLong(hwnd, GWL_USERDATA)

   'Copy the memory that points to the VTable of our original
   'control to the shadow copy of the control you use to
   'call the original control's WindowProc Function.
   'This way, when you call the method of the shadow control,
   'you are actually calling the original controls' method.
   CopyMemory oPlugin, ptrObject, 4

   'Call the WindowProc function in the instance of the UserControl.
   SubWndProc = oPlugin.WindowProc(hwnd, Msg, wParam, lParam)

   'Destroy the Shadow Control Copy
   CopyMemory oPlugin, 0&, 4
   Set oPlugin = Nothing

End Function
Public Function HiWord(dw As Long) As Integer

    If dw And &H80000000 Then
          HiWord = (dw \ 65535) - 1
    Else: HiWord = dw \ 65535
    End If
    
End Function
Public Function LoWord(dw As Long) As Integer

    If dw And &H8000& Then
          LoWord = &H8000& Or (dw And &H7FFF&)
    Else: LoWord = dw And &HFFFF&
    End If
    
End Function
